#![allow(deprecated)]
use std::fmt;
use std::str;
/// The type of detrending to apply to the signal. When absent, will default to the detrend behavior for that function.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum DetrendType {
    /// Removes the mean value of the signal.
    #[serde(rename = "CONSTANT")]
    Constant,
    /// Removes a best-fit linear trend from the signal.
    #[serde(rename = "LINEAR")]
    Linear,
    /// Does not perform any detrending.
    #[serde(rename = "NO_OP")]
    NoOp,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl DetrendType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            DetrendType::Constant => "CONSTANT",
            DetrendType::Linear => "LINEAR",
            DetrendType::NoOp => "NO_OP",
            DetrendType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for DetrendType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for DetrendType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for DetrendType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(v: &str) -> Result<DetrendType, conjure_object::plain::ParseEnumError> {
        match v {
            "CONSTANT" => Ok(DetrendType::Constant),
            "LINEAR" => Ok(DetrendType::Linear),
            "NO_OP" => Ok(DetrendType::NoOp),
            v => v.parse().map(|v| DetrendType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for DetrendType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<DetrendType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the DetrendType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
